// 7K87K_ao.cpp : Defines the entry point for the console application.
//

#include <windows.h>
#include <stdio.h>
#include <TCHAR.h>
#include <string.h>
#include <stdlib.h>

#include "PACSDK.h"

#pragma comment(lib,"pacsdk.lib")

int _tmain(int argc, _TCHAR* argv[])
{
		BOOL err,bQuit;
		TCHAR strErr[32];
		
		float fAO_Value = 0;
		char connectionstring[32];
		int iAddr=1,iCom=2;
		int iAOChannels=4 ,iChannel =0 ,iNum=0;
		
		printf("ICPDAS (R) SDK Demo for XP-8000\n\n");
		printf("This demo is for remote 87K and 7K modules.\n\n");
	
		//Get com port
		printf("Input com's connectionstring(like\"COM2,9600,N,8,1\"):");
		scanf("%s",connectionstring);
		//Open com port except COM1,COM1 is for local.
		//This demo is for remote 87K and 7K modules.		
		HANDLE hPort = uart_Open(connectionstring);
		if(hPort == INVALID_HANDLE_VALUE)
		{
			pac_GetErrorMessage(pac_GetLastError(), strErr);
			printf("Open Error: %s. The error code is %x\n", strErr, pac_GetLastError());
			return 0;
		}	
		
		//Get address
		printf("Input address(hex):");
		scanf("%x",&iAddr);
		//Get DO total channels
		printf("Input AO total channels:");
		scanf("%d",&iAOChannels);
		

		bQuit=false;
        while(!bQuit){
			printf(
				"\n1.Write AO value and Read AO value\n"
				"2.exit\n"
				"Input number:"
			);
			scanf("%d",&iNum);
			switch(iNum){
			case 1:	 
				printf("Input channel to write AO:");
		  		scanf("%d",&iChannel);		

				printf("Input AO value(hex):");
		  		scanf("%f",&fAO_Value);			   
				pac_WriteAO(hPort,PAC_REMOTE_IO(iAddr),iChannel ,iAOChannels,fAO_Value);
				printf("Write AO value %f\n",fAO_Value);
					  
				err = pac_ReadAO(hPort, PAC_REMOTE_IO(iAddr),iChannel,  iAOChannels,  &fAO_Value);				
				printf("The read back AO's value is %f\n", fAO_Value);
				printf("Press any key to continue...");
				getchar();
            break;
			   case 2:
			      bQuit=true;
			   break;
      		}
			fflush(stdin);
		}
		
		err = uart_Close(hPort);
		if(err == FALSE)
		{
			pac_GetErrorMessage(pac_GetLastError(), strErr);
			printf("Close Error: %s. The error code is %x\n", strErr, pac_GetLastError());
			return 0;
		}	
		return 0;
		
}
